SystemOrganization addCategory: #'ContextS2-Tests'!
SystemOrganization addCategory: #'ContextS2-Tests-Sandbox'!

Object subclass: #CSClassA
	instanceVariableNames: 'executedMethods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2-Tests-Sandbox'!

!CSClassA methodsFor: 'accessing' stamp: ''!
executed: aSymbol

	self executedMethods add: aSymbol.! !

!CSClassA methodsFor: 'accessing' stamp: ''!
executedMethods
	"Answer the value of executedMethods"

	^ executedMethods! !

!CSClassA methodsFor: 'accessing' stamp: ''!
executedMethods: anObject
	"Set the value of executedMethods"

	executedMethods := anObject! !

!CSClassA methodsFor: 'accessing' stamp: ''!
executedMethodsArray

	^ self executedMethods asArray! !

!CSClassA methodsFor: 'partial methods' stamp: 'tfel 4/11/2012 13:37'!
getCurrentLayerA

	^ self currentLayers! !

!CSClassA methodsFor: 'partial methods' stamp: ''!
getCurrentLayerA
	<layer: #a>
	^ self currentLayers! !

!CSClassA methodsFor: 'partial methods' stamp: ''!
getCurrentLayerAB
	<layer: #(a b)>
	^ self currentLayers! !

!CSClassA methodsFor: 'partial methods' stamp: ''!
getCurrentLayerBA
	<layer: #(b a)>
	^ self currentLayers! !

!CSClassA methodsFor: 'partial methods' stamp: ''!
getCurrentLayerOf: aSymbol on: aLayer
	<layer: #a>
	aLayer withLayerDo: [ ^ self perform: aSymbol ].! !

!CSClassA methodsFor: 'partial methods' stamp: ''!
getCurrentLayerOf: aSymbol on: aLayer
	<layer: #additional>
	aLayer withLayerDo: [ ^ self perform: aSymbol ].! !

!CSClassA methodsFor: 'partial methods' stamp: ''!
getCurrentLayerOf: aSymbol on: aLayer
	<layer: #b>
	aLayer withLayerDo: [ ^ self perform: aSymbol ].! !

!CSClassA methodsFor: 'initialize-release' stamp: ''!
initialize
	
	self executedMethods: OrderedCollection new.! !

!CSClassA methodsFor: 'partial methods' stamp: 'tfel 4/11/2012 13:39'!
myMethod

	self executed: #base.! !

!CSClassA methodsFor: 'partial methods' stamp: ''!
myMethod
	<layer: #after>
	self proceed.
	self executed: #after.! !

!CSClassA methodsFor: 'partial methods' stamp: ''!
myMethod
	<layer: #before>
	self executed: #before.
	self proceed.! !

!CSClassA methodsFor: 'partial methods' stamp: ''!
myMethod
	<layer: #proceed1>
	self executed: #proceed1before.
	self proceed.
	self executed: #proceed1after.! !

!CSClassA methodsFor: 'partial methods' stamp: ''!
myMethod
	<layer: #proceed2>
	self executed: #proceed2before.
	self proceed.
	self executed: #proceed2after.! !

!CSClassA methodsFor: 'partial methods' stamp: ''!
myMethod
	<layer: #replace>
	self executed: #replace! !

!CSClassA methodsFor: 'partial methods' stamp: 'tfel 4/11/2012 13:38'!
myMethod: arg1 and: arg2
	
	^ arg1 + arg2! !

!CSClassA methodsFor: 'partial methods' stamp: ''!
myMethod: arg1 and: arg2
	<layer: #someLayer>
	
	^ (self proceed: arg1 with: arg2) + 1! !

!CSClassA methodsFor: 'partial methods' stamp: ''!
myMethod: arg1 and: arg2
	<layer: #someLayer2>
	
	^ (self proceed: arg1 with: arg2) + 1! !

!CSClassA methodsFor: 'partial methods' stamp: 'tfel 4/11/2012 13:40'!
myReturnMethod

	^ #base! !

!CSClassA methodsFor: 'partial methods' stamp: ''!
myReturnMethod
	<layer: #replacedReturn>
	^ #replacedReturn! !

!CSClassA methodsFor: 'non local return' stamp: ''!
nonLocalReturn
	|  aBlock |
	aBlock :=  [^ false].
	#l1 withLayerDo: [self valueBlock: aBlock].! !

!CSClassA methodsFor: 'non local return' stamp: ''!
valueBlock: aBlock

	aBlock value.! !

Object subclass: #CSClassB
	instanceVariableNames: 'count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2-Tests-Sandbox'!

!CSClassB methodsFor: 'accessing' stamp: ''!
count

	^ count! !

!CSClassB methodsFor: 'initialize-release' stamp: ''!
initialize

	count := 1.! !

CSClassB subclass: #CSSubclassB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2-Tests-Sandbox'!

Object subclass: #CSMyClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2-Tests-Sandbox'!

!CSMyClass methodsFor: 'as yet unclassified' stamp: ''!
bla! !

!CSMyClass methodsFor: 'partial methods' stamp: ''!
bla
	<layer: #l4>! !

!CSMyClass methodsFor: 'as yet unclassified' stamp: ''!
blub
	"BASE"! !

!CSMyClass methodsFor: 'partial methods' stamp: ''!
blub
	<layer: #(l1 l2 l5)>
	self blub.
	3 +4 +7! !

!CSMyClass methodsFor: 'partial methods' stamp: 'tfel 3/7/2012 11:40:42.475'!
blub
	<layer: #(l42)>
	self proceed.
	^ 42! !

!CSMyClass methodsFor: 'as yet unclassified' stamp: ''!
no
	self blub.! !

!CSMyClass methodsFor: 'partial methods' stamp: ''!
partialOnly

	<layer: #l1>! !

!CSMyClass methodsFor: 'partial methods' stamp: ''!
partialOnly

	<layer: #l2>! !

!CSMyClass methodsFor: 'partial methods' stamp: ''!
partialOnly
	<layer: #l5>
	self blub.! !

CSMyClass subclass: #CSMyClassSub
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2-Tests-Sandbox'!

!CSMyClassSub methodsFor: 'as yet unclassified' stamp: ''!
blub

	"neu in sub"! !

!CSMyClassSub methodsFor: 'as yet unclassified' stamp: ''!
no
! !

!CSMyClassSub methodsFor: 'partial methods' stamp: ''!
partialOnly
	<layer: #l4>
	self huhu.
	super partialOnly.! !

Object subclass: #CSTestRenderingInterface
	instanceVariableNames: 'loggedInUser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2-Tests-Sandbox'!

!CSTestRenderingInterface methodsFor: 'rendering' stamp: 'ag 1/27/2012 16:37:04.448'!
getCanvas
	
	^ Transcript! !

!CSTestRenderingInterface methodsFor: 'rendering' stamp: 'ag 2/1/2012 16:26:33.654'!
logInUser: aUser
	
	loggedInUser := aUser.! !

!CSTestRenderingInterface methodsFor: 'rendering' stamp: 'ag 2/1/2012 16:26:22.283'!
loggedInUser
	
	^ loggedInUser! !

!CSTestRenderingInterface methodsFor: 'rendering' stamp: 'ag 2/1/2012 16:33:04.915'!
logout
	
	loggedInUser := nil.! !

!CSTestRenderingInterface methodsFor: 'rendering' stamp: 'ag 2/1/2012 16:25:48.54'!
showUser: aUser
	
	(self loggedInUser
		ifNil: [ { loggedOutLayer } ]
		ifNotNilDo: [ :loggedInUser |
			loggedInUser isAdmin
				ifTrue: [ { editableLayer } ]
				ifFalse: [ {} ]])
					withLayersDo: [ aUser renderDetails: self getCanvas ].! !

Object subclass: #CSTestUser
	instanceVariableNames: 'username admin'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2-Tests-Sandbox'!

!CSTestUser class methodsFor: 'instance creation' stamp: 'ag 1/27/2012 16:51:21.396'!
named: aString
	
	^ self new username: aString; yourself! !

!CSTestUser methodsFor: 'rendering' stamp: 'ag 2/1/2012 16:28:17.724'!
beAdmin
	
	admin := true.! !

!CSTestUser methodsFor: 'rendering' stamp: 'ag 2/1/2012 16:29:17.02'!
initialize
	
	super initialize.
	admin := false.! !

!CSTestUser methodsFor: 'rendering' stamp: 'ag 2/1/2012 16:28:10.628'!
isAdmin
	
	^ admin! !

!CSTestUser methodsFor: 'rendering' stamp: 'ag 1/27/2012 16:32:12.59'!
renderDetails: aCanvas
	
	self
		renderProfileIcon: aCanvas;
		renderUsername: aCanvas;
		renderEmail: aCanvas.! !

!CSTestUser methodsFor: 'rendering' stamp: 'ag 1/27/2012 16:52:28.335'!
renderEditButton: aCanvas
	
	aCanvas cr; show: 'Edit button for user ', username.! !

!CSTestUser methodsFor: 'rendering' stamp: 'ag 1/27/2012 16:32:29.492'!
renderEmail: aCanvas
	
	aCanvas cr; show: 'Email icon of user ', username.! !

!CSTestUser methodsFor: 'rendering' stamp: 'ag 2/1/2012 16:27:28.193'!
renderForbidden: aCanvas
	
	aCanvas cr; show: 'Forbidden to view user ', username, '!!'.! !

!CSTestUser methodsFor: 'rendering' stamp: 'ag 1/27/2012 16:32:38.278'!
renderProfileIcon: aCanvas
	
	aCanvas cr; show: 'Profile icon of user ', username.! !

!CSTestUser methodsFor: 'rendering' stamp: 'ag 2/1/2012 16:29:58.116'!
renderUsername: aCanvas
	
	aCanvas cr; show: 'Username of user ', username.! !

!CSTestUser methodsFor: 'rendering' stamp: 'ag 1/27/2012 16:34:40.556'!
username
	
	^ username! !

!CSTestUser methodsFor: 'rendering' stamp: 'ag 1/27/2012 16:34:48.534'!
username: aString
	
	username := aString! !

CSLayer subclass: #CSTestLayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2-Tests-Sandbox'!

!CSTestLayer class methodsFor: 'layer instances' stamp: 'ag 12/22/2011 16:40'!
globalLayerName
	
	^ #cstest! !

TestCase subclass: #CSTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2-Tests'!

CSTestCase subclass: #CSBehavioralVariationsTest
	instanceVariableNames: 'a'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2-Tests'!

!CSBehavioralVariationsTest methodsFor: 'accessing' stamp: 'mpe 11/7/2010 18:30'!
a
	"Answer the value of a"

	^ a! !

!CSBehavioralVariationsTest methodsFor: 'accessing' stamp: 'mpe 11/7/2010 18:30'!
a: anObject
	"Set the value of a"

	a := anObject! !

!CSBehavioralVariationsTest methodsFor: 'running' stamp: 'ag 12/21/2011 20:58'!
layers: someLayers shouldResultIn: anArrayOfSymbols
	
	someLayers withLayersDo: [ self a myMethod ].
	self assert: self a executedMethods size = anArrayOfSymbols size.
	self assert: self a executedMethodsArray = anArrayOfSymbols.! !

!CSBehavioralVariationsTest methodsFor: 'running' stamp: 'mpe 11/7/2010 18:30'!
setUp

	self a: CSClassA new.! !

!CSBehavioralVariationsTest methodsFor: 'testing' stamp: 'ag 1/27/2012 17:31:58.672'!
test01ExecuteBaseMethod
	
	self
		layers: #()
		shouldResultIn: #(base).! !

!CSBehavioralVariationsTest methodsFor: 'testing' stamp: 'ag 12/21/2011 16:05'!
test02ExecuteBeforeBaseMethod
	
	self
		layers: #(before)
		shouldResultIn: #(before base).! !

!CSBehavioralVariationsTest methodsFor: 'testing' stamp: 'ag 1/30/2012 11:44:02.336'!
test04aExecuteBeforeBaseAfterMethod
	
	self
		layers: #(before after)
		shouldResultIn: #(before base after).! !

!CSBehavioralVariationsTest methodsFor: 'testing' stamp: 'ag 12/21/2011 16:06'!
test04bExecuteBeforeBaseAfterMethod
	
	self
		layers: #(after before)
		shouldResultIn: #(before base after).! !

!CSBehavioralVariationsTest methodsFor: 'testing' stamp: 'ag 12/21/2011 16:06'!
test05ExecuteAroundMethod
	
	self
		layers: #(replace)
		shouldResultIn: #(replace).! !

!CSBehavioralVariationsTest methodsFor: 'testing' stamp: 'ag 12/21/2011 16:06'!
test06ExecuteAroundProceedBaseMethod
	
	self
		layers: #(proceed1)
		shouldResultIn: #(proceed1before base proceed1after).! !

!CSBehavioralVariationsTest methodsFor: 'testing' stamp: 'ag 12/21/2011 16:07'!
test07aExecuteAroundProceedAroundMethod
	
	self
		layers: #(proceed1 replace)
		shouldResultIn: #(proceed1before replace proceed1after).! !

!CSBehavioralVariationsTest methodsFor: 'testing' stamp: 'ag 12/21/2011 20:40'!
test07bExecuteAroundProceedAroundMethod
	
	self
		layers: #(replace proceed1)
		shouldResultIn: #(replace).! !

!CSBehavioralVariationsTest methodsFor: 'testing' stamp: 'ag 12/21/2011 16:07'!
test08ExecuteBeforeAroundAfterMethod
	
	self
		layers: #(before replace after)
		shouldResultIn: #(before replace).! !

!CSBehavioralVariationsTest methodsFor: 'testing' stamp: 'ag 12/21/2011 20:57'!
test09ExecuteBeforeAroundProceedBaseAfterMethod
	
	self
		layers: #(before proceed1 after)
		shouldResultIn: #(before proceed1before base after proceed1after).! !

!CSBehavioralVariationsTest methodsFor: 'testing' stamp: 'ag 12/21/2011 20:42'!
test09aExecuteBeforeAroundProceedBaseAfterMethod
	
	self
		layers: #(proceed1 before after)
		shouldResultIn: #(proceed1before before base after proceed1after).! !

!CSBehavioralVariationsTest methodsFor: 'testing' stamp: 'ag 12/21/2011 16:11'!
test10ExecuteBeforeAroundProceedAroundAfterMethod
	
	self
		layers: #(before replace proceed1 after)
		shouldResultIn: #(before replace).! !

!CSBehavioralVariationsTest methodsFor: 'testing' stamp: 'ag 12/21/2011 16:11'!
test10aExecuteBeforeAroundProceedAroundAfterMethod
	
	self
		layers: #(after before replace proceed1)
		shouldResultIn: #(before replace after).! !

!CSBehavioralVariationsTest methodsFor: 'testing' stamp: 'ag 12/21/2011 20:57'!
test11aReturnValueFromAround
	
	#replacedReturn withLayerDo: [ self assert: self a myReturnMethod = #replacedReturn ].! !

!CSBehavioralVariationsTest methodsFor: 'testing' stamp: 'ag 12/21/2011 12:01'!
test11bReturnValueFromBase
	
	self assert: self a myReturnMethod = #base.! !

!CSBehavioralVariationsTest methodsFor: 'testing' stamp: 'ag 12/21/2011 16:13'!
test12MultipleChainedProceeds
	
	self
		layers: #(proceed1 proceed2)
		shouldResultIn: #(proceed1before proceed2before base proceed2after proceed1after).! !

!CSBehavioralVariationsTest methodsFor: 'testing' stamp: 'ag 12/21/2011 20:58'!
test13MultipleChainedProceedsWithoutBase
	
	self
		layers: #(proceed1 proceed2 replace)
		shouldResultIn: #(proceed1before proceed2before replace proceed2after proceed1after).! !

!CSBehavioralVariationsTest methodsFor: 'testing' stamp: 'ag 12/21/2011 16:14'!
test13aMultipleChainedProceedsWithoutBase
	
	self
		layers: #(replace proceed1 proceed2)
		shouldResultIn: #(replace).! !

!CSBehavioralVariationsTest methodsFor: 'testing' stamp: 'ag 12/23/2011 16:57'!
test14MultiArgumentProceed
	
	#(someLayer someLayer2) withLayersDo: [ self assert: 19 = (CSClassA new myMethod: 12 and: 5) ].! !

!CSBehavioralVariationsTest methodsFor: 'testing' stamp: 'tfel 3/7/2012 12:04:09.927'!
test15BaseMethodOverriddenInSubclassWithLayerInSuperclass
	
	self assert: (#l42 withLayerDo: [CSMyClassSub new blub]) ~= 42! !

CSTestCase subclass: #CSContextSTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2-Tests'!

CSContextSTest subclass: #CSAddingMethodsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2-Tests'!

!CSAddingMethodsTest methodsFor: 'testing' stamp: 'ag 12/22/2011 11:55'!
addMethodFrom: code
	
	self addMethodFrom: code toClass: CSClassA.! !

!CSAddingMethodsTest methodsFor: 'testing' stamp: 'ag 12/22/2011 11:55'!
test01AddCompiledMethodExistingNil
	
	self addMethodFrom: self baseCode.
	self assert: self generatedMethod class == CompiledMethod.! !

!CSAddingMethodsTest methodsFor: 'testing' stamp: 'ag 12/22/2011 11:55'!
test02AddCompiledMethodExistingCompiledMethod
	
	| compiledMethod |
	self addMethodFrom: self baseCode.
	compiledMethod := self generatedMethod.
	self addMethodFrom: self baseCode.
	self deny: self generatedMethod == compiledMethod.! !

!CSAddingMethodsTest methodsFor: 'testing' stamp: 'pre 8/17/2020 15:50'!
test03aAddCompiledMethodExistingLayeredMethodWithoutBase
	
	| layeredMethod |
	self addMethodFrom: self singleLayerCode.
	layeredMethod := self generatedMethod.
	self deny: layeredMethod includesBaseMethod.
	self assert: layeredMethod baseMethod isNil.
	
	self addMethodFrom: self baseCode.
	layeredMethod := self generatedMethod.
	self assert: layeredMethod includesBaseMethod.
	self assert: layeredMethod partialMethods size == 1.
	self assert: layeredMethod partialMethods first class == CSPartialMethod.
	self assert: layeredMethod baseMethod class == CompiledMethod.! !

!CSAddingMethodsTest methodsFor: 'testing' stamp: 'pre 8/17/2020 15:51'!
test03bAddCompiledMethodExistingLayeredMethodWithBase
	
	| layeredMethod oldBaseMethod |
	self addMethodFrom: self baseCode.
	self addMethodFrom: self singleLayerCode.
	layeredMethod := self generatedMethod.
	self assert: layeredMethod partialMethods size = 1.
	oldBaseMethod := layeredMethod baseMethod.
	
	self addMethodFrom: self baseCode.
	layeredMethod := self generatedMethod.
	self assert: layeredMethod partialMethods size = 1.
	self deny: layeredMethod baseMethod == oldBaseMethod.! !

!CSAddingMethodsTest methodsFor: 'testing' stamp: 'ag 12/22/2011 11:58'!
test04AddPartialMethodExistingNil
	
	| layeredMethod |
	self addMethodFrom: self singleLayerCode.
	layeredMethod := self generatedMethod.
	self assert: layeredMethod class == CSLayeredMethod.
	self deny: layeredMethod includesBaseMethod.
	self assert: layeredMethod partialMethods size = 1.! !

!CSAddingMethodsTest methodsFor: 'testing' stamp: 'tfel 2/29/2012 09:57:13.749'!
test05AddPartialMethodExistingCompiledMethod
	
	| compiledMethod layeredMethod |
	self addMethodFrom: self baseCode.
	compiledMethod := self generatedMethod.
	self assert: compiledMethod class == CompiledMethod.
	
	self addMethodFrom: self singleLayerCode.
	layeredMethod := self generatedMethod.
	self assert: layeredMethod class == CSLayeredMethod.
	self assert: layeredMethod partialMethods size = 1.
	self assert: layeredMethod basePartialMethod method == compiledMethod.
	self assert: layeredMethod partialMethods first class == CSPartialMethod.
	self assert: layeredMethod baseMethod == compiledMethod.! !

!CSAddingMethodsTest methodsFor: 'testing' stamp: 'tfel 2/29/2012 10:23:24.443'!
test06aAddPartialMethodExistingLayeredMethodLayerNoCombinationNotExistingWithBase
	
	| layeredMethod oldPartial |
	self addMethodFrom: self baseCode.
	self addMethodFrom: self singleLayerCode.
	layeredMethod := self generatedMethod.
	self assert: layeredMethod partialMethods size = 1.
	self assert: layeredMethod partialMethods first layers = #(l1).
	self assert: layeredMethod includesBaseMethod.
	oldPartial := layeredMethod partialMethods first.
	
	[self addMethodFrom: self threeLayersCode] valueSupplyingAnswer: true.
	self assert: layeredMethod partialMethods size = 1.
	self assert: layeredMethod partialMethods first layers = #(l1 l2 l3).
	self assert: layeredMethod partialMethods first ~= oldPartial.! !

!CSAddingMethodsTest methodsFor: 'testing' stamp: 'tfel 2/29/2012 10:23:03.368'!
test06bAddPartialMethodExistingLayeredMethodLayerNoCombinationNotExistingWithoutBase
	
	| layeredMethod |
	self addMethodFrom: self singleLayerCode.
	layeredMethod := self generatedMethod.
	self assert: layeredMethod partialMethods size = 1.
	self assert: layeredMethod partialMethods first layers = #(l1).
	self deny: layeredMethod includesBaseMethod.
	
	[self addMethodFrom: self threeLayersCode] valueSupplyingAnswer: true.
	self assert: layeredMethod partialMethods size = 1.
	self assert: layeredMethod partialMethods first layers = #(l1 l2 l3).
	self deny: layeredMethod includesBaseMethod.! !

!CSAddingMethodsTest methodsFor: 'testing' stamp: 'ag 12/23/2011 11:31'!
test06cAddPartialMethodExistingLayeredMethodLayerCombinationExistingSingle
	
	| layeredMethod oldPartialMethod |
	self addMethodFrom: self baseCode.
	self addMethodFrom: self singleLayerCode.
	layeredMethod := self generatedMethod.
	self assert: layeredMethod partialMethods size = 1.
	oldPartialMethod := layeredMethod partialMethods first.
	
	self addMethodFrom: self singleLayerCode.
	self assert: layeredMethod partialMethods size = 1.
	self assert: layeredMethod partialMethods first layers = #(l1).
	self deny: layeredMethod partialMethods first == oldPartialMethod.! !

!CSAddingMethodsTest methodsFor: 'testing' stamp: 'pre 8/17/2020 15:53'!
test06dAddPartialMethodExistingLayeredMethodLayerCombinationExistingMultiple
	
	| layeredMethod  oldBaseMethod oldPartialMethod |
	self addMethodFrom: self baseCode.
	self addMethodFrom: self threeLayersCode.
	layeredMethod := self generatedMethod.
	self assert: layeredMethod partialMethods size = 1.
	oldPartialMethod := layeredMethod partialMethods first.
	oldBaseMethod := layeredMethod baseMethod.
	
	self addMethodFrom: self threeLayersCode.
	self assert: layeredMethod partialMethods size = 1.
	self assert: layeredMethod partialMethods first layers = #(l1 l2 l3).
	self deny: layeredMethod partialMethods first == oldPartialMethod.
	self assert: layeredMethod baseMethod == oldBaseMethod.
	oldPartialMethod := layeredMethod partialMethods first.
	
	self addMethodFrom: self baseCode.
	layeredMethod := self generatedMethod.
	self deny: layeredMethod baseMethod == oldBaseMethod.
	self assert: layeredMethod partialMethods first == oldPartialMethod.! !

!CSAddingMethodsTest methodsFor: 'testing' stamp: 'pre 8/17/2020 15:56'!
test07aChangingBaseMethodCreatesNewLayeredMethod
	
	|  layeredMethod1 layeredMethod2 |
	self addMethodFrom: self baseCode.
	self addMethodFrom: self threeLayersCode.
	layeredMethod1 := self generatedMethod.
	self addMethodFrom: self baseCode.
	layeredMethod2 := self generatedMethod.
	self assert: layeredMethod1 ~~ layeredMethod2! !

!CSAddingMethodsTest methodsFor: 'testing' stamp: 'pre 8/17/2020 15:56'!
test07bChangingPartialMethodCreatesNewLayeredMethod
	
	|  layeredMethod1 layeredMethod2 |
	self addMethodFrom: self baseCode.
	self addMethodFrom: self threeLayersCode.
	layeredMethod1 := self generatedMethod.
	self addMethodFrom: self threeLayersCode.
	layeredMethod2 := self generatedMethod.
	self assert: layeredMethod1 ~~ layeredMethod2! !

CSContextSTest subclass: #CSCompilerExtensionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2-Tests'!

!CSCompilerExtensionTest methodsFor: 'testing' stamp: 'topa 2/26/2016 13:38'!
compile: aSourceCodeString
	"This does not add the method to the class."
	
	| methodAndNode |
	methodAndNode := CSClassA
		compile: aSourceCodeString
		notifying: nil
		trailer: (self class defaultMethodTrailer)
		ifFail: [self error: 'cannot compile test source: ', aSourceCodeString].
	self deny: (CSClassA methodDict includes: self generatedSelector).
	^ methodAndNode method! !

!CSCompilerExtensionTest methodsFor: 'testing' stamp: 'ag 12/22/2011 13:44'!
test01CompileBaseMethod
	
	self assert: (self compile: self baseCode) class = CompiledMethod.! !

!CSCompilerExtensionTest methodsFor: 'testing' stamp: 'ag 1/27/2012 17:15:30.036'!
test02CompileBaseMethodAsPartialMethod
	
	| method |
	method := (self compile: self baseCode) asPartialMethod.
	self assert: method class = CSPartialMethod.
	self assert: method layers isEmpty.
	self assert: method isBase.
	self assert: method method class == CompiledMethod.
	self assert: method method = (self compile: self baseCode).! !

!CSCompilerExtensionTest methodsFor: 'testing' stamp: 'ag 12/23/2011 11:31'!
test03aCompileMultipleLayers
	
	| method |
	method := self compile: self singleLayerCode.
	self assert: method class = CSPartialMethod.
	self assert: method layers = #(l1).
	self assert: method method class == CompiledMethod.! !

!CSCompilerExtensionTest methodsFor: 'testing' stamp: 'ag 12/23/2011 11:31'!
test03bCompileMultipleLayers
	
	| method |
	method := self compile: self threeLayersCode.
	self assert: method class = CSPartialMethod.
	self assert: method layers = #(l1 l2 l3).
	self assert: method method class == CompiledMethod.! !

!CSContextSTest class methodsFor: 'constants' stamp: 'ag 12/21/2011 21:35'!
generatedSelector

	^ #generatedPartialMethod! !

!CSContextSTest class methodsFor: 'testing' stamp: 'topa 3/15/2016 14:23'!
isAbstract

	^ self name = #CSContextSTest! !

!CSContextSTest methodsFor: 'running' stamp: 'topa 3/15/2016 14:21'!
addMethodFrom: aSourceCodeString toClass: aClass
	| changeStamp |
	changeStamp := (Utilities respondsTo: #changeStamp)
				ifTrue: [Utilities changeStamp]
				ifFalse: [Smalltalk at: #Author ifPresent: [:A | A changeStamp] ifAbsent: ['unknown']].
	aClass
		compile: aSourceCodeString
		classified: 'partial methods generated during tests'
		withStamp: changeStamp
		notifying: nil.
	self assert: (aClass methodDict includesKey: self generatedSelector).! !

!CSContextSTest methodsFor: 'method code' stamp: 'ag 12/21/2011 21:40'!
baseCode
	
	^ self codeForLayers: nil! !

!CSContextSTest methodsFor: 'method code' stamp: 'ag 12/22/2011 13:47'!
codeForLayers: layerSymbols
	"Method code contains only"
	
	^ self codeForLayers: layerSymbols withContent: ''! !

!CSContextSTest methodsFor: 'method code' stamp: 'ag 12/22/2011 13:47'!
codeForLayers: layerSymbols withContent: contentString
	"Method code contains only"
	
	^ (self generatedSelector, 
		'\"This method has been generated by ', self class name, 
		' and may be deleted."\',
		(layerSymbols ifNil: [ '' ] ifNotNil: [ '<layer: ', layerSymbols printString, '>' ]),
		contentString)
			withCRs! !

!CSContextSTest methodsFor: 'running' stamp: 'ag 12/22/2011 11:42'!
deleteMethod
	
	CSClassA removeSelector: self generatedSelector.! !

!CSContextSTest methodsFor: 'accessing' stamp: 'topa 3/15/2016 14:22'!
generatedMethod
	
	^ CSClassA compiledMethodAt: self generatedSelector! !

!CSContextSTest methodsFor: 'accessing' stamp: 'ag 12/21/2011 21:35'!
generatedSelector

	^ self class generatedSelector! !

!CSContextSTest methodsFor: 'running' stamp: 'ag 12/22/2011 11:42'!
setUp
	
	self
		deleteMethod;
		deny: (CSClassA methodDict includesKey: self generatedSelector).! !

!CSContextSTest methodsFor: 'method code' stamp: 'ag 12/22/2011 11:51'!
singleLayerCode
	
	^ self codeForLayers: #l1! !

!CSContextSTest methodsFor: 'running' stamp: 'ag 1/27/2012 17:19:43.173'!
tearDown
	
	self deleteMethod.
	super tearDown.! !

!CSContextSTest methodsFor: 'method code' stamp: 'ag 12/22/2011 11:51'!
threeLayersCode
	
	^ self codeForLayers: #(l1 l2 l3)! !

!CSContextSTest methodsFor: 'method code' stamp: 'ag 12/22/2011 11:52'!
twoLayersCode
	
	^ self codeForLayers: #(l1 l2)! !

CSContextSTest subclass: #CSPartialMethodTest
	instanceVariableNames: 'partialMethod'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2-Tests'!

!CSPartialMethodTest methodsFor: 'running' stamp: 'ag 12/22/2011 13:50'!
deleteMethod
	
	super deleteMethod.
	CSClassB removeSelector: self generatedSelector.
	CSSubclassB removeSelector: self generatedSelector.! !

!CSPartialMethodTest methodsFor: 'method code' stamp: 'ag 12/22/2011 13:48'!
partialCountMethod
	
	^ self codeForLayers: #l1 withContent: '^ count + 1'! !

!CSPartialMethodTest methodsFor: 'running' stamp: 'ag 12/22/2011 13:59'!
partialMethodFrom: aClass
	
	^ (aClass >> self generatedSelector) partialMethods first! !

!CSPartialMethodTest methodsFor: 'method code' stamp: 'ag 12/22/2011 13:49'!
partialSubCountMethod
	
	^ self codeForLayers: #l1 withContent: '^ super generatedPartialMethod + count'! !

!CSPartialMethodTest methodsFor: 'method code' stamp: 'ag 12/22/2011 13:49'!
partialSubSuperCountMethod
	
	^ self codeForLayers: #l1 withContent: '^ super count'! !

!CSPartialMethodTest methodsFor: 'running' stamp: 'ag 12/22/2011 13:50'!
setUp
	
	super setUp.
	self addMethodFrom: self partialCountMethod toClass: CSClassB.! !

!CSPartialMethodTest methodsFor: 'testing' stamp: 'ag 12/23/2011 11:31'!
test01CompilePartialMethodAndToClass
	
	| partialMethod |
	partialMethod := self partialMethodFrom: CSClassB.
	self assert: partialMethod layers = #(l1).
	self assert: partialMethod method class == CompiledMethod.
	self assert: partialMethod method selector == self generatedSelector.
	self assert: partialMethod method methodClass == CSClassB.! !

!CSPartialMethodTest methodsFor: 'testing' stamp: 'topa 3/15/2016 14:26'!
test02aCallPartialMethod
	
	self assert: 2 equals: ((self partialMethodFrom: CSClassB) valueWithReceiver: CSClassB new arguments: #()).! !

!CSPartialMethodTest methodsFor: 'testing' stamp: 'ag 12/22/2011 14:04'!
test02bCallPartialMethodFromInstance
	
	#l1 withLayerDo: [ self assert: CSClassB new generatedPartialMethod = 2 ].! !

!CSPartialMethodTest methodsFor: 'testing' stamp: 'ag 12/22/2011 14:00'!
test03CallPartialMethodWithSuperCall
	
	CSClassB methodDict at: self generatedSelector put: (self partialMethodFrom: CSClassB).
	self addMethodFrom: self partialSubCountMethod toClass: CSSubclassB.
	CSSubclassB methodDict at: self generatedSelector put: (self partialMethodFrom: CSSubclassB).
	self assert: CSSubclassB new generatedPartialMethod = 3.! !

!CSPartialMethodTest methodsFor: 'testing' stamp: 'ag 12/22/2011 14:05'!
test03aCallPartialMethodWithSuperCall
	
	self addMethodFrom: self partialSubCountMethod toClass: CSSubclassB.
	#l1 withLayerDo: [ self assert: CSSubclassB new generatedPartialMethod = 3 ].! !

!CSPartialMethodTest methodsFor: 'testing' stamp: 'ag 12/22/2011 14:05'!
test04CallPartialMethodWithSuperCallToStandardMethod
	
	CSClassB methodDict at: self generatedSelector put: (self partialMethodFrom: CSClassB).
	self addMethodFrom: self partialSubSuperCountMethod toClass: CSSubclassB.
	CSSubclassB methodDict at: self generatedSelector put: (self partialMethodFrom: CSSubclassB).
	self assert: CSSubclassB new generatedPartialMethod = 1.! !

!CSPartialMethodTest methodsFor: 'testing' stamp: 'ag 12/22/2011 14:00'!
test05CallPartialMethodFromSubclass

	CSClassB methodDict at: self generatedSelector put: (self partialMethodFrom: CSClassB).
	self assert: CSSubclassB new generatedPartialMethod = 2.! !

!CSPartialMethodTest methodsFor: 'testing' stamp: 'ag 12/22/2011 14:06'!
test05aCallPartialMethodFromSubclass
	
	#l1 withLayerDo: [ self assert: CSSubclassB new generatedPartialMethod = 2 ].! !

CSTestCase subclass: #CSLayerInstancesTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2-Tests'!

!CSLayerInstancesTest methodsFor: 'constants' stamp: 'ag 12/22/2011 17:14'!
layerName
	
	^ #testlayer! !

!CSLayerInstancesTest methodsFor: 'testing-current-layer' stamp: 'ag 12/23/2011 11:34'!
test1NoCurrentLayer
	
	self assert: self currentLayers isNil.! !

!CSLayerInstancesTest methodsFor: 'testing-current-layer' stamp: 'ag 12/23/2011 11:34'!
test2NestedLayersNoCurrentLayer
	
	#a withLayerDo: [
		#b withLayerDo: [
			self assert: self currentLayers isNil ] ].! !

!CSLayerInstancesTest methodsFor: 'testing-current-layer' stamp: 'ag 12/23/2011 11:34'!
test3SingleLayerNoCurrentLayer
	
	#a withLayerDo: [ self assert: self currentLayers isNil ].! !

!CSLayerInstancesTest methodsFor: 'testing-current-layer' stamp: 'ag 1/30/2012 13:12:23.986'!
test4CurrentLayerWithoutPartialMethod
	
	#zzz withLayerDo: [ self assert: CSClassA new getCurrentLayerA isNil ].! !

!CSLayerInstancesTest methodsFor: 'testing-current-layer' stamp: 'ag 12/23/2011 11:36'!
test5CurrentLayerSingleLayer
	
	| layer |
	#a withLayerDo: [ layer := CSClassA new getCurrentLayerA ].
	self assert: layer notNil.
	self assert: layer size == 1.
	self assert: layer first layerName == #a.! !

!CSLayerInstancesTest methodsFor: 'testing-current-layer' stamp: 'ag 12/23/2011 11:39'!
test5aCurrentLayerSingleLayer
	
	| layer |
	#(b a) withLayersDo: [ layer := CSClassA new getCurrentLayerA ].
	self assert: layer notNil.
	self assert: layer size == 1.
	self assert: layer first layerName == #a.! !

!CSLayerInstancesTest methodsFor: 'testing-current-layer' stamp: 'ag 12/23/2011 11:36'!
test6CurrentLayerSingleLayerTwoLayerMethod
	
	| layer |
	#a withLayerDo: [ layer := CSClassA new getCurrentLayerAB ].
	self assert: layer notNil.
	self assert: layer size == 1.
	self assert: layer first layerName == #a.! !

!CSLayerInstancesTest methodsFor: 'testing-current-layer' stamp: 'ag 12/23/2011 11:36'!
test7CurrentLayerSingleLayerTwoLayerMethod2
	
	| layer |
	#b withLayerDo: [ layer := CSClassA new getCurrentLayerAB ].
	self assert: layer notNil.
	self assert: layer size == 1.
	self assert: layer first layerName == #b.! !

!CSLayerInstancesTest methodsFor: 'testing-current-layer' stamp: 'ag 12/23/2011 11:37'!
test8CurrentLayerMultipleLayersTwoLayerMethod
	
	| layer |
	#(a b) withLayersDo: [ layer := CSClassA new getCurrentLayerAB ].
	self assert: layer notNil.
	self assert: layer size == 2.
	self assert: (layer collect: #layerName) = #(a b).! !

!CSLayerInstancesTest methodsFor: 'testing-current-layer' stamp: 'tfel 3/28/2012 14:00:17.75'!
test9CurrentLayerMultipleLayersTwoLayerMethod2
	
	| layer |
	#(a b) withLayersDo: [ layer := CSClassA new getCurrentLayerBA ].
	self assert: layer notNil.
	self assert: layer size == 2.
	self assert: (layer collect: #layerName) sort = #(a b).! !

!CSLayerInstancesTest methodsFor: 'testing' stamp: 'ag 12/22/2011 17:22'!
testAnonymousLayerInstance
	
	| instance |
	CSLayer layerNamed: self layerName.
	self assert: (Smalltalk includesKey: self layerName).
	CSLayer resetLayer: self layerName.
	self assert: (Smalltalk includesKey: self layerName) not.
	instance := CSLayer layerNamed: self layerName.
	self assert: (Smalltalk at: self layerName) == instance.! !

!CSLayerInstancesTest methodsFor: 'testing' stamp: 'ag 12/22/2011 17:20'!
testAnonymousLayerInstanceReplaced
	
	| instance |
	CSLayer resetLayer: self layerName.
	instance := CSLayer layerNamed: self layerName.
	CSLayer resetLayer: self layerName.
	self deny: (CSLayer layerNamed: self layerName) == instance.! !

!CSLayerInstancesTest methodsFor: 'testing' stamp: 'ag 12/22/2011 17:21'!
testAnonymousLayerInstanceSame
	
	| instance |
	CSLayer resetLayer: self layerName.
	instance := CSLayer layerNamed: self layerName.
	self assert: (CSLayer layerNamed: self layerName) == instance.! !

!CSLayerInstancesTest methodsFor: 'testing' stamp: 'ag 12/22/2011 17:22'!
testSubclassedLayerInstance
	"This tests 2 things: #resetInstance (removes the global variable) and #instance (creates it and adds it as global variable)"
	
	| instance |
	CSTestLayer instance.
	self assert: (Smalltalk includesKey: CSTestLayer globalLayerName).
	CSTestLayer resetInstance.
	self assert: (Smalltalk includesKey: CSTestLayer globalLayerName) not.
	instance := CSTestLayer instance.
	self assert: (Smalltalk at: CSTestLayer globalLayerName) == instance.! !

!CSLayerInstancesTest methodsFor: 'testing' stamp: 'ag 12/23/2011 12:00'!
testSubclassedLayerInstanceAccessableWithLayerNamed
	
	| instance |
	instance := CSTestLayer instance.
	self assert: instance == (CSLayer layerNamed: CSTestLayer globalLayerName).
	CSTestLayer resetInstance.
	instance := CSTestLayer instance.
	self assert: instance == (CSLayer layerNamed: CSTestLayer globalLayerName).! !

!CSLayerInstancesTest methodsFor: 'testing' stamp: 'ag 12/22/2011 17:22'!
testSubclassedLayerInstanceReplaced
	
	| instance |
	CSTestLayer resetInstance.
	instance := CSTestLayer instance.
	CSTestLayer resetInstance.
	self deny: CSTestLayer instance == instance.! !

!CSLayerInstancesTest methodsFor: 'testing' stamp: 'ag 12/23/2011 13:53'!
testSubclassedLayerInstanceResettableWithLayerNamed
	
	| instance |
	instance := CSTestLayer instance.
	CSLayer resetLayer: CSTestLayer globalLayerName.
	self deny: instance == CSTestLayer instance.! !

!CSLayerInstancesTest methodsFor: 'testing' stamp: 'ag 12/22/2011 17:21'!
testSubclassedLayerInstanceSame
	
	| instance |
	CSTestLayer resetInstance.
	instance := CSTestLayer instance.
	self assert: CSTestLayer instance == instance.! !

!CSLayerInstancesTest methodsFor: 'testing-current-layer' stamp: 'tfel 3/28/2012 14:01:29.043'!
testz10CurrentLayerMultipleLayersTwoLayerMethod3
	
	| layer |
	#(b a) withLayersDo: [ layer := CSClassA new getCurrentLayerAB ].
	self assert: layer notNil.
	self assert: layer size == 2.
	self assert: (layer collect: #layerName) sort = #(a b).! !

!CSLayerInstancesTest methodsFor: 'testing-current-layer' stamp: 'ag 12/23/2011 11:44'!
testz11CurrentLayerNestedCalls
	"First partial method on layer #b is run, and inside another partial method on layer #a."
	
	| layer |
	#b withLayerDo: [ layer := CSClassA new getCurrentLayerOf: #getCurrentLayerA on: #a ].
	self assert: layer notNil.
	self assert: layer size == 1.
	self assert: layer first layerName == #a.! !

!CSLayerInstancesTest methodsFor: 'testing-current-layer' stamp: 'ag 12/23/2011 11:47'!
testz12CurrentLayerNestedCalls2
	"Current Layer not changed when another partial method is invoked in its base version."
	
	| layer |
	#b withLayerDo: [ layer := CSClassA new getCurrentLayerOf: #getCurrentLayerA on: #zzz ].
	self assert: layer notNil.
	self assert: layer size == 1.
	self assert: layer first layerName == #b.! !

!CSLayerInstancesTest methodsFor: 'testing-current-layer' stamp: 'ag 12/23/2011 11:48'!
testz12CurrentLayerNestedCalls3
	
	| layer |
	#a withLayerDo: [ layer := CSClassA new getCurrentLayerOf: #getCurrentLayerA on: #zzz ].
	self assert: layer notNil.
	self assert: layer size == 1.
	self assert: layer first layerName == #a.! !

!CSLayerInstancesTest methodsFor: 'testing-current-layer' stamp: 'ag 12/23/2011 11:48'!
testz12CurrentLayerNestedCalls4
	
	| layer |
	#b withLayerDo: [ layer := CSClassA new getCurrentLayerOf: #getCurrentLayerAB on: #zzz ].
	self assert: layer notNil.
	self assert: layer size == 1.
	self assert: layer first layerName == #b.! !

!CSLayerInstancesTest methodsFor: 'testing-current-layer' stamp: 'ag 12/23/2011 11:48'!
testz12CurrentLayerNestedCalls5
	
	| layer |
	#b withLayerDo: [ layer := CSClassA new getCurrentLayerOf: #getCurrentLayerBA on: #zzz ].
	self assert: layer notNil.
	self assert: layer size == 1.
	self assert: layer first layerName == #b.! !

CSTestCase subclass: #CSLayerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2-Tests'!

!CSLayerTest methodsFor: 'accessing' stamp: 'ag 12/17/2011 21:52'!
activeLayers

	^ self process csInfo activeLayers! !

!CSLayerTest methodsFor: 'accessing' stamp: 'mp 6/11/2010 20:54'!
process
	^ Processor activeProcess! !

!CSLayerTest methodsFor: 'layer tests' stamp: 'ag 12/17/2011 21:50'!
test01LayerCollectionInitialization

	self assert: self activeLayers isEmpty.! !

!CSLayerTest methodsFor: 'layer tests' stamp: 'ag 12/17/2011 21:50'!
test02aSingleLayerActivation
	#l1 withLayerDo: [
		self assert: self activeLayers notEmpty.
		self assert: self activeLayers first = #l1.
		].
	self assert: self activeLayers isEmpty.! !

!CSLayerTest methodsFor: 'layer tests' stamp: 'ag 12/17/2011 21:51'!
test02bSingleLayerActivation
	#(l1) withLayersDo: [
		self assert: self activeLayers notEmpty.
		self assert: self activeLayers first = #l1.
		].
	self assert: self activeLayers isEmpty.! !

!CSLayerTest methodsFor: 'layer tests' stamp: 'ag 12/21/2011 11:50'!
test03ComplicatedNestedLayerActivation
	#l1 withLayerDo: [
		self assert: self activeLayers notEmpty.
		self assert: self activeLayers first = #l1.
		#(l1 l2 l3) withLayersDo: [
			self assert: self activeLayers size = 3.
			self assert: self activeLayers first = #l1.
			self assert: self activeLayers last = #l3.
			#l1 withoutLayerDo: [
				self assert: self activeLayers size = 2.
				self assert: self activeLayers first = #l2.
				self assert: self activeLayers last = #l3.
				].
			self assert: self activeLayers size = 3.
			self assert: self activeLayers first = #l1.
			self assert: self activeLayers last = #l3.
			].
		self assert: self activeLayers size = 1.
		self assert: self activeLayers first = 'l1'.
		].
	self assert: self activeLayers isEmpty.! !

!CSLayerTest methodsFor: 'layer tests' stamp: 'ag 12/17/2011 21:51'!
test03NestedLayerActivation
	#l1 withLayerDo: [
		self assert: self activeLayers notEmpty.
		self assert: self activeLayers first = #l1.
		#l1 withLayerDo: [
			self assert: self activeLayers size = 1.
			self assert: self activeLayers first = #l1.
			#l1 withLayerDo: [
				self assert: self activeLayers size = 1.
				self assert: self activeLayers first = #l1.
				]
			].
		self assert: self activeLayers size = 1.
		self assert: self activeLayers first = 'l1'.
		].
	self assert: self activeLayers isEmpty.! !

!CSLayerTest methodsFor: 'layer tests' stamp: 'ag 12/17/2011 21:51'!
test04LayerDeactivation
	#l1 withLayerDo: [
		self assert: self activeLayers size = 1.
		self assert: self activeLayers first = #l1.
		#l1 withoutLayerDo: [
			self assert: self activeLayers isEmpty.
			].
		self assert: self activeLayers size = 1.
		self assert: self activeLayers first = #l1.
		].
	self assert: self activeLayers isEmpty.! !

!CSLayerTest methodsFor: 'layer tests' stamp: 'ag 12/17/2011 21:51'!
test05MultipleLayerDeactivation
	#(l1 l2 l3) withLayersDo: [
		self assert: self activeLayers size = 3.
		self assert: self activeLayers last = #l3.
		#l2 withoutLayerDo: [
			self assert: self activeLayers size = 2.
			self assert: self activeLayers last = #l3.
			self assert: self activeLayers first = #l1].
		self assert: self activeLayers size = 3.
		self assert: self activeLayers second = #l2.
		#(l1 l2) withoutLayersDo: [
			#l3 withoutLayerDo: [self assert: self activeLayers isEmpty].
			self assert: self activeLayers first = #l3].
		self assert: self activeLayers size = 3.
		].
	self assert: self activeLayers isEmpty.! !

!CSLayerTest methodsFor: 'layer tests' stamp: 'ag 12/17/2011 21:51'!
test06LayerDeactivationInNonLocalReturns
	self assert: self activeLayers isEmpty.
	self deny: CSClassA new nonLocalReturn.
	self assert: self activeLayers isEmpty.! !

!CSTestCase class methodsFor: 'testing' stamp: 'topa 3/15/2016 14:24'!
isAbstract

	^ self name = #CSTestCase! !

!CSTestCase methodsFor: 'running' stamp: 'ag 1/31/2012 15:37:35.213'!
checkConsistencyEachTest
	
	^ false! !

!CSTestCase methodsFor: 'running' stamp: 'ag 1/31/2012 15:38:40.644'!
tearDown
	"This throws an assertion-error, if one of the method-instances becomes inconsistent."
	
	self checkConsistencyEachTest ifTrue: [
		[ CSMethodObject checkAllInstances ]
			on: Exception do: [ :e |
				Transcript cr; show: 'Inconsistency after test (in ', self class name , '): ', e, '. Trying to fix inconsistency.'.
				CSMethodObject fixAllInstances ] ].! !

CSTestCase subclass: #CSzzzConsistencyTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2-Tests'!

!CSzzzConsistencyTest methodsFor: 'testing' stamp: 'tfel 3/6/2012 11:39:21.595'!
testConsistency
	"The message-send in this test throws an AssertionError, if the consistency of the ContextS-classes and objects is broken.
	This test is executed once after all the other tests, therefore the classname with the 'zzz'-part.
	If this test fails, it seems there is a bug somewhere. You can (try to) restore system-consistency with the following DoIt:"
	"CSMethodObject fixAllInstances"
	
	CSMethodObject checkAllInstances.
	"If the checks pass, run fix anyway, because there are non-fatal problems that don't error when using check, but can be fixed anyways (like empty selectors or non-categorized partial methods)"
	CSMethodObject fixAllInstances.! !
